berou/accounts/urls.py
from django.conf import settings
from django.conf.urls import url

from accounts import views

urlpatterns = [
    url(r'^$', views.RegisterUserView.as_view(), name='register_user'),
    url(r'^login/$',
        views.LoginUserView.as_view(),
        name='login_user'),
    url(r'^logout/$', 'django.contrib.auth.views.logout',
        {'next_page': settings.LOGOUT_REDIRECT_URL},
        name='logout_user'),
    url(r'^profile/(?P<pk>\d+)$',
        views.ProfileView.as_view(),
        name='profile'),
    url(r'^edit_profile/(?P<pk>\d+)$',
        views.EditProfileView.as_view(),
        name='edit_profile'),
    url(r'^change_password/$',
        views.ChangePasswordView.as_view(),
        name='change_password'),
]

berou/berou/urls.py
# -*- coding: utf-8 -*-

import importlib
import logging

from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin

from accounts import urls as accounts_urls
from berou import berou_urls
from application_system import urls as application_system_urls
from application_system import models

logger = logging.getLogger('berou')


def get_plugin_packages():
    return [app.package for app in models.App.objects.all()]


urlpatterns = [
    # Examples:
    # url(r'^$', 'berou.views.home', name='home'),
    # url(r'^blog/', include('blog.urls')),

    url(r'^admin/', include(admin.site.urls)),
    url(r'^accounts/', include(accounts_urls, namespace='accounts')),
    url(r'^application_system/', include(application_system_urls,
                                         namespace='application_system')),
    url(r'^', include(berou_urls, namespace='berou')),

]

for plugin in get_plugin_packages():
    plugin_package = importlib.import_module(plugin)

    try:
        urls = importlib.import_module('{app}.urls'.format(app=plugin))
    except ImportError as error:
        if error != ('No module named urls',):
            raise
        else:
            logger.info('App {pp} does not have a urls file', app=plugin)
    else:
        plugin_urls = url(
            r'^{plugin}/'.format(plugin=plugin),
            include(urls, namespace=plugin)
        )
        urlpatterns.append(plugin_urls)

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)

berou/blog/urls.py
from django.conf.urls import url
from blog import views

urlpatterns = [
    url(r'^create$', views.CreatePostView.as_view(), name='create'),
    url(r'^$', views.ListPostView.as_view(), name='list'),
    url(r'^test$', views.Test.as_view(), name='list'),

    # url(r'^$', views.ListPostView.as_view(), name='list'),
 ]

berou/accounts/models.py
from django.db import models

# Create your models here.

berou/accounts/forms.py
# -*- coding: utf-8 -*-

from django import forms
from django.contrib.auth import get_user_model
from django.utils.translation import ugettext_lazy as _


class RegisterUserForm(forms.ModelForm):
    """ Register User Form. """
    class Meta:
        model = get_user_model()
        fields = ['username', 'email']

    password1 = forms.CharField(
        widget=forms.PasswordInput,
        label=_('Password')
    )
    password2 = forms.CharField(
        widget=forms.PasswordInput,
        label=_('Confirm password')
    )

    def clean_password2(self):
        super(RegisterUserForm, self).clean()
        password1 = self.cleaned_data['password1']
        password2 = self.cleaned_data['password2']
        if password1 != password2:
            raise forms.ValidationError('The two passwords are different')
        return password1

    def save(self, *args, **kwargs):
        self.full_clean()
        self.instance.set_password(self.cleaned_data['password1'])
        self.instance.save(*args, **kwargs)
        return self.instance

berou/accounts/views.py
# -*- coding: utf-8 -*-

from django.conf import settings
from django.contrib.auth import (
    login, authenticate, get_user_model, forms as django_forms
)

from django.core.urlresolvers import reverse
from django.shortcuts import redirect
from django.utils.translation import ugettext as _
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, FormView, UpdateView
from django.contrib.auth.forms import PasswordChangeForm

from accounts import forms
from berou import mixins


class RegisterUserView(mixins.LoginExcludedMixin, CreateView):
    model = get_user_model()
    template_name = 'accounts/register_user.html'
    form_class = forms.RegisterUserForm

    success_url = settings.LOGIN_REDIRECT_URL

    def form_valid(self, form):
        response = super(RegisterUserView, self).form_valid(form)
        user = authenticate(username=form.cleaned_data['username'],
                            password=form.cleaned_data['password1'])
        login(self.request, user)
        return response


class LoginUserView(FormView):
    form_class = django_forms.AuthenticationForm
    template_name = 'accounts/login_user.html'
    success_url = settings.LOGIN_REDIRECT_URL

    def get(self, request, *args, **kwargs):
        if request.user.is_authenticated():
            return redirect(reverse('berou:home'))
        return super(LoginUserView, self).get(request, *args, **kwargs)

    def get_success_url(self):
        query_string = self.request.META['QUERY_STRING']
        if not query_string or not query_string.startswith('next='):
            return self.success_url
        return query_string.split('next=')[1]

    def form_valid(self, form):
        response = super(LoginUserView, self).form_valid(form)
        login(self.request, form.get_user())
        return response

    def get_form(self, form_class=None):
        form = super(LoginUserView, self).get_form(form_class)
        form.fields['username'].widget.attrs['placeholder'] = _('Username')
        form.fields['password'].widget.attrs['placeholder'] = _('Password')
        return form


class ProfileMixin(object):
    context_object_name = 'user_object'


class ProfileView(mixins.LoginRequiredMixin, ProfileMixin, DetailView):
    model = get_user_model()
    template_name = 'accounts/profile.html'


class EditProfileView(ProfileMixin, UpdateView):
    model = get_user_model()
    template_name = 'accounts/edit_profile.html'
    fields = ['first_name', 'last_name', 'email']

    def get_success_url(self):
        return reverse('accounts:profile', kwargs={'pk': self.object.id})


class ChangePasswordView(mixins.LoginRequiredMixin, FormView):
    form_class = PasswordChangeForm
    template_name = 'accounts/change_password.html'

    def get_form(self, form_class):
        if self.request.method == 'POST':
            return form_class(user=self.request.user, data=self.request.POST)
        return form_class(user=self.request.user)

    def get_success_url(self):
        return reverse('accounts:profile', kwargs={'pk': self.request.user.id})

    def form_valid(self, form):
        """ Saves the form, and relogs the user in. """
        user = self.request.user
        new_password = form.cleaned_data['new_password1']
        response = super(ChangePasswordView, self).form_valid(form)
        form.save()
        user = authenticate(username=user.username, password=new_password)
        login(self.request, user)
        return response

berou/accounts/templates/accounts/change_password.html
{% extends 'berou/base.html' %}
{% load form_helpers i18n %}
{% block content %}
<div class="row">
    <form class="form-horizontal container-fluid" method="POST">
        {% csrf_token %}
        {% include "berou/includes/field.html" with field=form.old_password %}
        {% include "berou/includes/field.html" with field=form.new_password1 %}
        {% include "berou/includes/field.html" with field=form.new_password2 %}
        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <button class="btn btn-primary" type="submit">{% trans "Change password" %}</button>
            </div>
        </div>
    </form>
</div>
{% endblock content %}

berou/accounts/templates/accounts/edit_profile.html
{% extends 'berou/base.html' %}
{% load form_helpers i18n %}
{% block content %}
<div class="row">
    <form class="form-horizontal container-fluid"method="POST">
        {% csrf_token %}
        <div class="form-group">
            <label class="control-label col-md-2" for="{{ form.username.auto_id }}">{% trans "Username" %}</label>
            <div class="col-md-10">
                <h5>{{ object.username }}</h5>
            </div>
        </div>
        {% include "berou/includes/field.html" with field=form.email %}
        {% include "berou/includes/field.html" with field=form.first_name %}
        {% include "berou/includes/field.html" with field=form.last_name %}
        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <button class="btn btn-primary" type="submit">{% trans "Edit Profile" %}</button>
            </div>
        </div>
    </form>
</div>
{% endblock content %}

berou/accounts/templates/accounts/login_user.html
{% extends 'berou/base.html' %}
{% load staticfiles form_helpers i18n %}
{% block content %}
<div class="row">
    <h1>{% trans "Login" %}</h1>
    <form class="form-horizontal" method="POST">
        {% csrf_token %}
        {% if form.non_field_errors %}
        <div class="alert alert-danger">
            <ul class="list-unstyled">
                {% for error in form.non_field_errors %}
                <li>{{ error }}</li>
                {% endfor %}
            </ul>
        </div>
        {% endif %}
        {% include "berou/includes/field.html" with field=form.username %}
        {% include "berou/includes/field.html" with field=form.password %}
        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <a href="{% url 'accounts:register_user' %}">{% trans "Register new account" %}</a>
            </div>
        </div>
        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <button class="btn btn-primary" type="submit">{% trans "Login" %}</button>
            </div>
        </div>
    </form>
</div>
{% endblock content %}

berou/accounts/templates/accounts/profile.html
{% extends 'berou/base.html' %}
{% load i18n %}
{% block content %}
<div class="row">
    <div class="panel panel-default">
        <div class="panel-heading">
            <div class="row">
                <div class="col-md-4">
                    <h4>{% trans "Profile" %}</h4>
                </div>
                <div class="col-md-8">
                    {% if user == object %}<a href="{% url 'accounts:edit_profile' pk=object.id %}" class="pull-right btn btn-primary">{% trans "Edit" %}</a>{% endif %}
                </div>
            </div>
        </div>
        <div class="panel-body">
            <dl class="dl-horizontal">
                <dt>{% trans "User name" %}</dt>
                <dd>{{ object.username }}</dd>
                <dt>{% trans "Password" %}</dt>
                <dd><a href="{% url 'accounts:change_password' %}">Change password</a></dd>
                <dt>{% trans "Email" %}</dt>
                <dd>{{ object.email }}</dd>
                <dt>{% trans "First name" %}</dt>
                <dd>{{ object.first_name }}</dd>
                <dt>{% trans "Last name" %}</dt>
                <dd>{{ object.last_name }}</dd>
                <dt>{% trans "Last login" %}</dt>
                <dd>{{ object.last_login }}</dd>
                <dt>{% trans "Date joined" %}</dt>
                <dd>{{ object.date_joined }}</dd>
            </dl>
        </div>
    </div>
</div>
{% endblock content %}

berou/accounts/templates/accounts/register_user.html
{% extends 'berou/base.html' %}
{% load staticfiles form_helpers i18n %}
{% block content %}
<div class="row">
    <h1>{% trans 'Register' %}</h1>
    <form class="form-horizontal container-fluid" method="POST">
        {% csrf_token %}
        {% include "berou/includes/field.html" with field=form.username %}
        {% include "berou/includes/field.html" with field=form.email %}
        {% include "berou/includes/field.html" with field=form.password1 %}
        {% include "berou/includes/field.html" with field=form.password2 %}
        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <button class="btn btn-primary" type="submit">{% trans "Register" %}</button>
            </div>
        </div>
    </form>
</div>
{% endblock content %}